clear all
close all

%% Data

% Maximum amplitude
all_first_vdn = cell2mat(struct2cell(load('all_first_perc_s_VDN.mat')));
all_second_vdn = cell2mat(struct2cell(load('all_second_perc_s_VDN.mat')));
all_third_vdn = cell2mat(struct2cell(load('all_third_perc_s_VDN.mat')));
all_fourth_vdn = cell2mat(struct2cell(load('all_fourth_perc_s_VDN.mat')));

all_second_alb = cell2mat(struct2cell(load('all_second_perc_s_ALB.mat')));
all_fourth_alb = cell2mat(struct2cell(load('all_fourth_perc_s_ALB.mat')));

all_first_nav = cell2mat(struct2cell(load('all_first_perc_s_NAV.mat')));
all_second_nav = cell2mat(struct2cell(load('all_second_perc_s_NAV.mat')));
all_third_nav = cell2mat(struct2cell(load('all_third_perc_s_NAV.mat')));
all_fourth_nav = cell2mat(struct2cell(load('all_fourth_perc_s_NAV.mat')));


% Maximum amplitude
all_first_imp_vdn = cell2mat(struct2cell(load('all_first_perc_imp_s_VDN.mat')));
all_second_imp_vdn = cell2mat(struct2cell(load('all_second_perc_imp_s_VDN.mat')));
all_third_imp_vdn = cell2mat(struct2cell(load('all_third_perc_imp_s_VDN.mat')));
all_fourth_imp_vdn = cell2mat(struct2cell(load('all_fourth_perc_imp_s_VDN.mat')));

all_second_imp_alb = cell2mat(struct2cell(load('all_second_perc_imp_s_ALB.mat')));
all_fourth_imp_alb = cell2mat(struct2cell(load('all_fourth_perc_imp_s_ALB.mat')));

all_first_imp_nav = cell2mat(struct2cell(load('all_first_perc_imp_s_NAV.mat')));
all_second_imp_nav = cell2mat(struct2cell(load('all_second_perc_imp_s_NAV.mat')));
all_third_imp_nav = cell2mat(struct2cell(load('all_third_perc_imp_s_NAV.mat')));
all_fourth_imp_nav = cell2mat(struct2cell(load('all_fourth_perc_imp_s_NAV.mat')));

%% Boxplot

%% Figure 10a

figure
subplot(3,1,1)
x1 = all_first_vdn;
x2 = all_second_vdn;
x3 = all_third_vdn;
x4 = all_fourth_vdn;
x = [x1;x2;x3;x4];
g1 = repmat(1,size(x1,1),size(x1,2));
g2 = repmat(2,size(x2,1),size(x2,2));
g3 = repmat(3,size(x3,1),size(x3,2));
g4 = repmat(4,size(x4,1),size(x4,2));
g = [g1; g2; g3;g4];
boxplot(x,g,'Notch','off','Colors','k','Symbol','kx','Widths',0.2)
ylim([0.1 100])
set(gca,'YScale','log')
yticks([1 10 100]);
yticklabels({'1','10','100'});
set(gca,'FontSize',30);
ylabel('% A_m_a_x')
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.YGrid = 'on';
set(gca,'xticklabel',{[]}) 
title('Avanon de Nant','FontSize',30,'FontWeight','normal')

subplot(3,1,2)
x1 = nan;
x2 = all_second_alb;
x3 = nan;
x4 = all_fourth_alb;
x = [x1;x2;x3;x4];
g1 = repmat({'1st'},size(x1,1),size(x1,2));
g2 = repmat({'2nd'},size(x2,1),size(x2,2));
g3 = repmat({'3rd'},size(x3,1),size(x3,2));
g4 = repmat({'4th'},size(x4,1),size(x4,2));
g = [g1;g2;g3; g4];
boxplot(x,g,'Notch','off','Colors','k','Symbol','kx','Widths',0.2)
set(gca,'YScale','log')
yticks([1 10 100]);
yticklabels({'1', '10', '100'});
ylim([0.1 100]);
set(gca,'FontSize',30);
ylabel('% A_m_a_x')
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.YGrid = 'on';
set(gca,'xticklabel',{[]})
title('Albula','FontSize',30,'FontWeight','normal')

subplot(3,1,3)
x1 = all_first_nav;
x2 = all_second_nav;
x3 = all_third_nav;
x4 = all_fourth_nav;
x = [x1;x2;x3;x4];
g1 = repmat({'1st'},size(x1,1),size(x1,2));
g2 = repmat({'2nd'},size(x2,1),size(x2,2));
g3 = repmat({'3rd'},size(x3,1),size(x3,2));
g4 = repmat({'4th'},size(x4,1),size(x4,2));
g = [g1; g2; g3;g4];
boxplot(x,g,'Notch','off','Colors','k','Symbol','kx','Widths',0.2)
set(gca,'YScale','log')
yticks([1 10 100]);
yticklabels({'1', '10', '100'});
ylim([0.1 100])
set(gca,'FontSize',30);
ylabel('% A_m_a_x')
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.YGrid = 'on';
title('Naviscence','FontSize',30,'FontWeight','normal')

%% Figure 10b
figure
subplot(3,1,1)
x1 = all_first_imp_vdn;
x2 = all_second_imp_vdn;
x3 = all_third_imp_vdn;
x4 = all_fourth_imp_vdn;
x = [x1;x2;x3;x4];
g1 = repmat(1,size(x1,1),size(x1,2));
g2 = repmat(2,size(x2,1),size(x2,2));
g3 = repmat(3,size(x3,1),size(x3,2));
g4 = repmat(4,size(x4,1),size(x4,2));
g = [g1; g2; g3;g4];
boxplot(x,g,'Notch','off','Colors','k','Symbol','kx','Widths',0.2)
ylim([0 100])
set(gca,'FontSize',30);
ylabel('% N_i_m_p')
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.YGrid = 'on';
set(gca,'xticklabel',{[]}) 
title('Avanon de Nant','FontSize',30,'FontWeight','normal')

subplot(3,1,2)
x1 = nan;
x2 = all_second_imp_alb;
x3 = nan;
x4 = all_fourth_imp_alb;
x = [x1;x2;x3;x4];
g1 = repmat({'1st'},size(x1,1),size(x1,2));
g2 = repmat({'2nd'},size(x2,1),size(x2,2));
g3 = repmat({'3rd'},size(x3,1),size(x3,2));
g4 = repmat({'4th'},size(x4,1),size(x4,2));
g = [g1;g2;g3; g4];
boxplot(x,g,'Notch','off','Colors','k','Symbol','kx','Widths',0.2)
ylim([0 100])
set(gca,'FontSize',30);
ylabel('% N_i_m_p')
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.YGrid = 'on';
set(gca,'xticklabel',{[]})
title('Albula','FontSize',30,'FontWeight','normal')

subplot(3,1,3)
x1 = all_first_imp_nav;
x2 = 0;
x3 = 0;
x4 = 0;
x = [x1;x2;x3;x4];
g1 = repmat({'1st'},size(x1,1),size(x1,2));
g2 = repmat({'2nd'},size(x2,1),size(x2,2));
g3 = repmat({'3rd'},size(x3,1),size(x3,2));
g4 = repmat({'4th'},size(x4,1),size(x4,2));
g = [g1; g2; g3;g4];
boxplot(x,g,'Notch','off','Colors','k','Symbol','kx','Widths',0.2)
ylim([0 100])
set(gca,'FontSize',30);
ylabel('% N_i_m_p')
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.YGrid = 'on';
title('Naviscence','FontSize',30,'FontWeight','normal')
