%% Gilles Antoniazza / June 2020

clear all
close all

% Load data

Geo2 =cell2mat(struct2cell(load('geo2.mat')));
Geo2(90,:)=[];
Geo2(70,:)=[];
Geo2(50,:)=[];
Geo2(40,:)=[];
Geo3 =cell2mat(struct2cell(load('geo3.mat'))); 
Geo3(90,:)=[];
Geo4 =cell2mat(struct2cell(load('geo4.mat')));       
Geo4(90,:)=[];
Geo4(80,:)=[];
Geo4(70,:)=[];
Geo4(50,:)=[];
Geo4(10,:)=[];
Geo5 =cell2mat(struct2cell(load('geo5.mat')));
Geo5(90,:)=[];
Geo5(80,:)=[];
Geo5(70,:)=[];
Geo5(20,:)=[];
Geo6 =cell2mat(struct2cell(load('geo6.mat')));       
Geo6(40,:)=[];
Geo7 =cell2mat(struct2cell(load('geo7.mat'))); 
Geo7(60,:)=[];
Geo8 =cell2mat(struct2cell(load('geo8.mat'))); 
Geo8(80,:)=[];
Geo8(60,:)=[];
Geo8(40,:)=[];
Geo9 =cell2mat(struct2cell(load('geo9.mat'))); 
Geo10 =cell2mat(struct2cell(load('geo10.mat')));  
Geo10(80,:)=[];
Geo11 =cell2mat(struct2cell(load('geo11.mat')));  
Geo11(90,:)=[];
Geo11(60,:)=[];
Geo12 =cell2mat(struct2cell(load('geo12.mat')));  
Geo12(90,:)=[];
Geo12(50,:)=[];
Geo13 =cell2mat(struct2cell(load('geo13.mat')));  
Geo13(90,:)=[];
Geo13(60,:)=[];
Geo13(50,:)=[];
Geo14 =cell2mat(struct2cell(load('geo14.mat')));  
Geo14(60,:)=[];
Geo15 =cell2mat(struct2cell(load('geo15.mat')));  
Geo15(60,:)=[];

%% Second neighbouring geophone%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
threshold = 2*10^-2;

%% All geophones

% Absolute
all_maxs = [Geo2(:,2);Geo3(:,3);Geo4(:,4);Geo5(:,5);Geo6(:,6);Geo7(:,7);Geo8(:,8);Geo9(:,9);Geo10(:,10);Geo11(:,11);Geo12(:,12);Geo13(:,13);Geo14(:,14);Geo15(:,15)];
all_maxs_second = [(Geo2(:,1)+Geo2(:,3))./2;Geo3(:,2);Geo4(:,5);(Geo5(:,4)+Geo5(:,6))./2;Geo6(:,5);Geo7(:,8);(Geo8(:,7)+Geo8(:,9))./2;Geo9(:,8);Geo10(:,11);(Geo11(:,10)+Geo11(:,12))./2; Geo12(:,11);Geo13(:,14);(Geo14(:,13)+Geo14(:,15))./2;Geo15(:,14)];
    
all_second_alb = [all_maxs all_maxs_second];

%%  Regression from x = 2*10^-2

all_second_alb_s = sortrows(all_second_alb);

lmax = log(all_second_alb_s(find(all_second_alb_s(:,1)>threshold),1));
lmax_second = log(all_second_alb_s(find(all_second_alb_s(:,1)>threshold),2));
p_second=polyfit(lmax,lmax_second,1);
x_fitline_second = lmax;
y_fitline_second = p_second(1)*x_fitline_second+p_second(2);
x_fitlog_second = exp(x_fitline_second);
y_fitlog_second = exp(y_fitline_second);
yfit_second = polyval(p_second,lmax);
yresid_second = lmax_second - yfit_second;
SSresid_second = sum(yresid_second.^2);
SStotal_second = (length(lmax)-1) * var(lmax);
rsq_second = 1 - SSresid_second/SStotal_second;


%% Fourth neighbouring geophone%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
threshold = 2*10^-2;

% Absolute
all_maxs_4 = [Geo3(:,3);Geo4(:,4);Geo6(:,6);Geo7(:,7);Geo9(:,9);Geo10(:,10);Geo12(:,12);Geo13(:,13);Geo15(:,15)];
all_maxs_fourth = [Geo3(:,1);Geo4(:,6);Geo6(:,4);Geo7(:,9);Geo9(:,7);Geo10(:,12);Geo12(:,10);Geo13(:,15);Geo15(:,13)];

all_fourth_alb = [all_maxs_4 all_maxs_fourth];

%% Regression from 2*10^-2

all_fourth_alb = sortrows([all_maxs_4 all_maxs_fourth]);

lmax_4 = log(all_fourth_alb(find(all_fourth_alb(:,1)>threshold),1));
lmax_fourth = log(all_fourth_alb(find(all_fourth_alb(:,1)>threshold),2));
p_fourth=polyfit(lmax_4,lmax_fourth,1);
x_fitline_fourth = lmax_4;
y_fitline_fourth = p_fourth(1)*x_fitline_fourth+p_fourth(2);
x_fitlog_fourth = exp(x_fitline_fourth);
y_fitlog_fourth = exp(y_fitline_fourth);
yfit_fourth = polyval(p_fourth,lmax_4);
yresid_fourth = lmax_fourth - yfit_fourth;
SSresid_fourth = sum(yresid_fourth.^2);
SStotal_fourth = (length(lmax_4)-1) * var(lmax_4);
rsq_fourth = 1 - SSresid_fourth/SStotal_fourth;

%% Attenuation
att = 4;
light = [251, 238, 230]/255;
dark = [110, 44, 0]/255;
colors_p = [linspace(light(1),dark(1),att)', linspace(light(2),dark(2),att)', linspace(light(3),dark(3),att)'];

figure
loglog(x_fitlog_second,y_fitlog_second,'Linewidth',2,'Color',colors_p(4,:))
hold on
loglog(x_fitlog_fourth,y_fitlog_fourth,'Linewidth',2,'Color',colors_p(2,:))
grid on
box off
xticks([0.01 0.1 1 10]);
xticklabels({'0.01','0.1','1','10'})
yticks([0.001 0.01 0.1 1]);
yticklabels({'0.001','0.01','0.1','1'})
xlabel('A_m_a_x [V]');
ylabel('A_m_a_x neigh. plate(s) [V]')
set(gca,'FontSize',40);
text(2*10^-2,5*10^-1,sprintf('y_2_n_d = %.3f x^{%.3f} / R^2 = %.3f',exp(p_second(2)),p_second(1),rsq_second),'Fontsize',40,'Color',colors_p(4,:))
text(2*10^-2,2*10^-1,sprintf('y_4_t_h = %.3f x^{%.3f} / R^2 = %.3f',exp(p_fourth(2)),p_fourth(1),rsq_fourth),'Fontsize',40,'Color',colors_p(2,:))
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.MinorGridLineStyle = ':'
ax.MinorGridAlpha = 1
xlim([1*10^-2 1*10^1]);
ylim([1*10^-3 1*10^0]);
