%% Gilles Antoniazza / June 2020

clear all
close all

% Figure 2

Data5 = load('64g_Reprod.txt'); % Reproducibility test / VAW laboratory / 0.064 kg - 0.1 m - 25 times

for i=1:10000:length(Data5);
Zeros10(i,1)=max(Data5(i:i+9999));
end

Max_64g = Zeros10(Zeros10>0);

for i = 1:5000000;
Max_64g_rand = randperm(25);   
Sx_rand(1:5,i) = [std(Max_64g(Max_64g_rand(1:5))) std(Max_64g(Max_64g_rand(1:10))) std(Max_64g(Max_64g_rand(1:15))) std(Max_64g(Max_64g_rand(1:20))) std(Max_64g(Max_64g_rand(1:25)))];
Mean_rand(1:5,i) = [mean(Max_64g(Max_64g_rand(1:5))) mean(Max_64g(Max_64g_rand(1:10))) mean(Max_64g(Max_64g_rand(1:15))) mean(Max_64g(Max_64g_rand(1:20))) mean(Max_64g(Max_64g_rand(1:25)))];
end

Mean_Sx= (mean(Sx_rand,2));
Mean_mean = (mean(Mean_rand,2));

Sort_Sx = sort(Sx_rand,2);

Sx_95pos = Sort_Sx(1:5,4750000);
Sx_95neg = Sort_Sx(1:5,250000);

%% Figure 2a

figure
plot([2 4 6 8 10],Sx_95pos,'--','Linewidth',3,'Color',[255 64 64]./255)
hold on
plot([2 4 6 8 10],Mean_Sx,'Linewidth',3,'Color',[255 64 64]./255)
hold on
plot([2 4 6 8 10],Sx_95neg,'--','Linewidth',3,'Color',[255 64 64]./255)
set(gca,'fontsize', 30)
xlabel('Number of impacts')
ylabel('Standard deviation [V]')
set(gca, 'XTick', [2 4 6 8 10])
set(gca, 'XTickLabel', {'After 5','After 10', 'After 15', 'After 20' ,'After 25', 'After 30'})
xlim([1 11])
ax = gca;
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
legend('95th centile','Mean standard deviation','5th centile')
grid on
box off
legend boxoff

%% Figure 2b

figure
plot(Data5(1:100000),'Color',[255 64 64]./255)
set(gca,'fontsize', 30)
xlabel('Time [s]')
ylabel('Raw signal [V]')
set(gca, 'XTick', [1*10^4 2*10^4 3*10^4 4*10^4 5*10^4 6*10^4 7*10^4 8*10^4 9*10^4 10*10^4])
set(gca, 'XTickLabel', {'1','2', '3', '4' ,'5', '6','7','8','9','10'})
box off