%% Gilles Antoniazza / June 2020

clear all
close all


%Kinetic energy of each category of weight/height 
Ec = [0.0064 0.0139 0.0275 0.0488 0.1111 0.2323 0.4574 0.8905 1.0639]; % Kinectic energy (from high speed camera data): Ec = 0.5 * mass [kg] * velocity^2 [m/s]

% Load data
Geo1 =cell2mat(struct2cell(load('geo1.mat')));       
Geo1=mat2cell(Geo1,[10],[1,1,1,1,1,1,1,1,1]);
Geo1{1,6}(10)=[];
Geo1{1,9}(10)=[];                                   
Geo2 =cell2mat(struct2cell(load('geo2.mat')));      
Geo2=mat2cell(Geo2,[10],[1,1,1,1,1,1,1,1,1]);
Geo2{1,7}(10)=[]; 
Geo2{1,9}(10)=[];                                   
Geo3 =cell2mat(struct2cell(load('geo3.mat')));      
Geo3=mat2cell(Geo3,[10],[1,1,1,1,1,1,1,1,1]);
Geo4 =cell2mat(struct2cell(load('geo4.mat')));       
Geo4=mat2cell(Geo4,[10],[1,1,1,1,1,1,1,1,1]);
Geo4{1,9}(10)=[];                                   
Geo5 =cell2mat(struct2cell(load('geo5.mat')));       
Geo5=mat2cell(Geo5,[10],[1,1,1,1,1,1,1,1,1]);
Geo6 =cell2mat(struct2cell(load('geo6.mat')));      
Geo6=mat2cell(Geo6,[10],[1,1,1,1,1,1,1,1,1]);
Geo6{1,9}(10)=[];                                    
Geo7 =cell2mat(struct2cell(load('geo7.mat')));       
Geo7=mat2cell(Geo7,[10],[1,1,1,1,1,1,1,1,1]);
Geo8 =cell2mat(struct2cell(load('geo8.mat')));       
Geo8=mat2cell(Geo8,[10],[1,1,1,1,1,1,1,1,1]);
Geo8{1,2}(10)=[];
Geo8{1,1}(10)=[];                                   
Geo9 =cell2mat(struct2cell(load('geo9.mat'))); 
Geo9=mat2cell(Geo9,[10],[1,1,1,1,1,1,1,1,1]);
Geo10 =cell2mat(struct2cell(load('geo10.mat')));     
Geo10=mat2cell(Geo10,[10],[1,1,1,1,1,1,1,1,1]);

%% Figure 5a

Geos = {Geo1',Geo2',Geo3',Geo4',Geo5',Geo6',Geo7',Geo8',Geo9',Geo10'};

for i = 1:10;
    temp = Geos{1,i};
    all_maxs_geos(:,i) = {vertcat(temp{1:9,1})};
    for j = 1:9;
      Mean_geos(j,i) = mean(temp{j,1});
      Std_geos(j,i) = std(temp{j,1});
      all_ec_geos(j,i) = {ones(length(temp{j,1}),1) .* Ec(j)};
    end
    all_Ec_geos(:,i)= {vertcat(all_ec_geos{1:9,i})};    
end

for i = 1:10;   
%len = log(all_Ec_geos{1,i});
len = log(Ec');
%lmax = log(all_maxs_geos{1,i});
lmax = log(Mean_geos(:,i));
p_geos(i)={polyfit(len,lmax,1)};
p=polyfit(len,lmax,1);
x_fitline = len;
y_fitline = p(1)*x_fitline+p(2);
x_fitlog_geos(i) = {exp(x_fitline)};
y_fitlog_geos(i) = {exp(y_fitline)};
yfit = polyval(p,len);
yresid = lmax - yfit;
SSresid = sum(yresid.^2);
SStotal = (length(len)-1) * var(len);
rsq_geos(i) = {1 - SSresid/SStotal};
end

figure
set(gca, 'XScale', 'log')
set(gca, 'YScale', 'log')
sensors = 10;
light = [235, 245, 251]/255;
dark = [27, 79, 144]/255;
colors_p = [linspace(light(1),dark(1),sensors)', linspace(light(2),dark(2),sensors)', linspace(light(3),dark(3),sensors)'];
for i=1:10;
    h1 =loglog(x_fitlog_geos{1,i},y_fitlog_geos{1,i},'Linewidth',2,'Color',colors_p(i,:));
    hold on
     h2 =loglog(Ec',Mean_geos(:,i),'o','Color',colors_p(i,:),'Markersize',10,'Linewidth',2,'HandleVisibility','off');
  hold on
end
legend('Geo1','Geo2','Geo3','Geo4','Geo5','Geo6','Geo7','Geo8','Geo9','Geo10','Location','Southeast')
legend boxoff
box off
grid on
grid on;
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.MinorGridLineStyle = ':'
ax.MinorGridAlpha = 1
xlabel('Kinetic energy [J]');
xticklabels({'0.01','0.1','1'})
yticklabels({'0.01','0.1','1','10'})
ylabel('A_m_a_x [V]')
set(gca,'FontSize',40);

for i = 1:10;
    stats(i,1:3) = [exp(p_geos{1,i}(2)) p_geos{1,i}(1) rsq_geos{1,i}];
end

%writematrix(stats,'stats_adn.xls');