%% Gilles Antoniazza / June 2020


clear all
close all

% Kinetic energy of each category of weight/height 
Ec = [0.0064 0.0139 0.0275 0.0488 0.1111 0.2323 0.4574 0.8905 1.0639]; % Kinectic energy (from high speed camera): Ec = 0.5 * mass [kg] * velocity^2 [m/s]

% Load data
                                                           
Geo2 =cell2mat(struct2cell(load('max_geo_02.mat')));       
Geo2=mat2cell(Geo2,[10],[1,1,1,1,1,1,1,1,1]);
Geo2{1,9}(10)=[];
Geo2{1,7}(10)=[];
Geo2{1,5}(10)=[];
Geo2{1,4}(10)=[];                                          
Geo3 =cell2mat(struct2cell(load('max_geo_03.mat')));      
Geo3=mat2cell(Geo3,[10],[1,1,1,1,1,1,1,1,1]);
Geo3{1,9}(10)=[];                                          
Geo4 =cell2mat(struct2cell(load('max_geo_04.mat')));       
Geo4=mat2cell(Geo4,[10],[1,1,1,1,1,1,1,1,1]);
Geo4{1,5}(10)=[];
Geo4{1,7}(10)=[];
Geo4{1,8}(10)=[];
Geo4{1,9}(10)=[];
Geo4{1,1}(10)=[];                                          
Geo5 =cell2mat(struct2cell(load('max_geo_05.mat')));       
Geo5=mat2cell(Geo5,[10],[1,1,1,1,1,1,1,1,1]);
Geo5{1,7}(10)=[];
Geo5{1,8}(10)=[];
Geo5{1,9}(10)=[];
Geo5{1,2}(10)=[];                                          
Geo6 =cell2mat(struct2cell(load('max_geo_06.mat')));       
Geo6=mat2cell(Geo6,[10],[1,1,1,1,1,1,1,1,1]); 
Geo6{1,4}(10)=[];                                          
Geo7 =cell2mat(struct2cell(load('max_geo_07.mat')));       
Geo7=mat2cell(Geo7,[10],[1,1,1,1,1,1,1,1,1]);
Geo7{1,6}(10)=[];                                         
Geo8 =cell2mat(struct2cell(load('max_geo_08.mat')));       
Geo8=mat2cell(Geo8,[10],[1,1,1,1,1,1,1,1,1]);
Geo8{1,6}(10)=[];
Geo8{1,4}(10)=[];
Geo8{1,8}(10)=[];                                          
Geo9 =cell2mat(struct2cell(load('max_geo_09.mat')));       
Geo9=mat2cell(Geo9,[10],[1,1,1,1,1,1,1,1,1]);
Geo10 =cell2mat(struct2cell(load('max_geo_10.mat')));       
Geo10=mat2cell(Geo10,[10],[1,1,1,1,1,1,1,1,1]);
Geo10{1,8}(10)=[];
Geo11 =cell2mat(struct2cell(load('max_geo_11.mat')));  
Geo11=mat2cell(Geo11,[10],[1,1,1,1,1,1,1,1,1]);
Geo11{1,9}(10)=[];
Geo11{1,6}(10)=[];                                        
Geo12 =cell2mat(struct2cell(load('max_geo_12.mat')));  
Geo12=mat2cell(Geo12,[10],[1,1,1,1,1,1,1,1,1]);
Geo12{1,5}(10)=[];
Geo12{1,9}(10)=[];                                         
Geo13 =cell2mat(struct2cell(load('max_geo_13.mat')));  
Geo13=mat2cell(Geo13,[10],[1,1,1,1,1,1,1,1,1]);
Geo13{1,9}(10)=[];
Geo13{1,6}(10)=[];                                         
Geo13{1,5}(10)=[];  
Geo14 =cell2mat(struct2cell(load('max_geo_14.mat')));  
Geo14=mat2cell(Geo14,[10],[1,1,1,1,1,1,1,1,1]);
Geo14{1,6}(10)=[];                                          
Geo15 =cell2mat(struct2cell(load('max_geo_15.mat')));  
Geo15=mat2cell(Geo15,[10],[1,1,1,1,1,1,1,1,1]);
Geo15{1,6}(10)=[];                                          

%% Figure 5b

Geos = {Geo2',Geo3',Geo4',Geo5',Geo6',Geo7',Geo8',Geo9',Geo10',Geo11',Geo12',Geo13',Geo14',Geo15'};

for i = 1:14;
    temp = Geos{1,i};
    all_maxs_geos(:,i) = {vertcat(temp{1:9,1})};
    for j = 1:9;
      Mean_geos(j,i) = mean(temp{j,1});
      Std_geos(j,i) = std(temp{j,1});
      all_ec_geos(j,i) = {ones(length(temp{j,1}),1) .* Ec(j)};
    end
    all_Ec_geos(:,i)= {vertcat(all_ec_geos{1:9,i})};    
end

for i = 1:14;   
%len = log(all_Ec_geos{1,i});
len = log(Ec');
%lmax = log(all_maxs_geos{1,i});
lmax = log(Mean_geos(:,i));
p_geos(i)={polyfit(len,lmax,1)};
p=polyfit(len,lmax,1);
x_fitline = len;
y_fitline = p(1)*x_fitline+p(2);
x_fitlog_geos(i) = {exp(x_fitline)};
y_fitlog_geos(i) = {exp(y_fitline)};
yfit = polyval(p,len);
yresid = lmax - yfit;
SSresid = sum(yresid.^2);
SStotal = (length(len)-1) * var(len);
rsq_geos(i) = {1 - SSresid/SStotal};
end

figure
set(gca, 'XScale', 'log')
set(gca, 'YScale', 'log')
sensors = 14;
light = [251, 238, 230]/255;
dark = [110, 44, 0]/255;
colors_p = [linspace(light(1),dark(1),sensors)', linspace(light(2),dark(2),sensors)', linspace(light(3),dark(3),sensors)'];
for i=1:14;
    h1 =loglog(x_fitlog_geos{1,i},y_fitlog_geos{1,i},'Linewidth',2,'Color',colors_p(i,:))
    hold on
     h2 =loglog(Ec',Mean_geos(:,i),'o','Color',colors_p(i,:),'Markersize',10,'Linewidth',2,'HandleVisibility','off')
  hold on
end
str = cellstr(["Geo2","Geo3","Geo4","Geo5","Geo6","Geo7","Geo8","Geo9","Geo10","Geo11","Geo12","Geo13","Geo14","Geo15"]);
columnlegend(3,str,'FontSize',40,'Location','SouthEast');
legend boxoff
box off
grid on;
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.MinorGridLineStyle = ':'
ax.MinorGridAlpha = 1
xlabel('Kinetic energy [J]');
xticklabels({'0.01','0.1','1'})
yticklabels({'0.01','0.1','1','10'})
ylabel('A_m_a_x [V]')
set(gca,'FontSize',40);

for i = 1:14;
    stats(i,1:3) = [exp(p_geos{1,i}(2)) p_geos{1,i}(1) rsq_geos{1,i}];
end

%writematrix(stats,'stats_alb.xls');