%% Neighbouring noise

clear all
close all

Geo1 =cell2mat(struct2cell(load('geo1.mat')));  
Geo1(90,:)=[];
Geo1(60,:)=[];
Geo2 =cell2mat(struct2cell(load('geo2.mat')));       %Load variable from .mat file 
Geo2(90,:)=[];
Geo2(70,:)=[];
Geo3 =cell2mat(struct2cell(load('geo3.mat'))); 
Geo4 =cell2mat(struct2cell(load('geo4.mat')));       %Load variable from .mat file
Geo4(90,:)=[];                            % Geophone only hit 9 times with last category
Geo5 =cell2mat(struct2cell(load('geo5.mat')));
Geo6 =cell2mat(struct2cell(load('geo6.mat')));       %Load variable from .mat file
Geo6(90,:)=[];                               % Geophone only hit 9 times with last category
Geo7 =cell2mat(struct2cell(load('geo7.mat'))); 
Geo8 =cell2mat(struct2cell(load('geo8.mat'))); 
Geo8(20,:)=[];
Geo8(10,:)=[];
Geo9 =cell2mat(struct2cell(load('geo9.mat')));
Geo10 =cell2mat(struct2cell(load('geo10.mat')));  

%% Percentage of the max. amplitude
Per_geo1 = Geo1 ./ Geo1(:,1).*100;
Per_geo2 = Geo2 ./ Geo2(:,2).*100;
Per_geo3 = Geo3 ./ Geo3(:,3).*100;
Per_geo4 = Geo4 ./ Geo4(:,4).*100;
Per_geo5 = Geo5 ./ Geo5(:,5).*100;
Per_geo6 = Geo6 ./ Geo6(:,6).*100;
Per_geo7 = Geo7 ./ Geo7(:,7).*100;
Per_geo8 = Geo8 ./ Geo8(:,8).*100;
Per_geo9 = Geo9 ./ Geo9(:,9).*100;
Per_geo10 = Geo10 ./ Geo10(:,10).*100;

%% Color
sensors = 10;
light = [235, 245, 251]/255;
dark = [27, 79, 144]/255;
colors_p = [linspace(light(1),dark(1),sensors)', linspace(light(2),dark(2),sensors)', linspace(light(3),dark(3),sensors)'];

%% First neighbouring geophone%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% All geophones

% Absolute
all_maxs = [Geo1(:,1);Geo2(:,2);Geo3(:,3);Geo4(:,4);Geo5(:,5);Geo6(:,6);Geo7(:,7);Geo8(:,8);Geo9(:,9);Geo10(:,10)];
all_maxs_first = [Geo1(:,2);(Geo2(:,1)+Geo2(:,3))./2;(Geo3(:,2)+Geo3(:,4))./2;(Geo4(:,3)+Geo4(:,5))./2;Geo5(:,4);Geo6(:,7);(Geo7(:,6)+Geo7(:,8))./2;(Geo8(:,7)+Geo8(:,9))./2;(Geo9(:,8)+Geo9(:,10))./2;Geo10(:,9)];

lmax = log(all_maxs);
lmax_first = log(all_maxs_first);
p_first=polyfit(lmax,lmax_first,1);
x_fitline_first = lmax;
y_fitline_first = p_first(1)*x_fitline_first+p_first(2);
x_fitlog_first = exp(x_fitline_first);
y_fitlog_first = exp(y_fitline_first);
yfit_first = polyval(p_first,lmax);
yresid_first = lmax_first - yfit_first;
SSresid_first = sum(yresid_first.^2);
SStotal_first = (length(lmax)-1) * var(lmax);
rsq_first = 1 - SSresid_first/SStotal_first;

all_first_vdn = [all_maxs all_maxs_first];
%save all_first_vdn.mat all_first_vdn

%Figure 7a
figure
loglog(all_maxs,all_maxs_first,'o','Linewidth',1,'Color',colors_p(7,:))
hold on
loglog(x_fitlog_first,y_fitlog_first,'Linewidth',2,'Color',colors_p(7,:))
grid on
box off
xticklabels({'0.01','0.1','1','10'})
yticklabels({'0.001','0.01','0.1','1'})
xlabel('A_m_a_x [V]');
ylabel('A_m_a_x 1st plate(s) [V]')
set(gca,'FontSize',40);
text(2*10^-2,5*10^-1,sprintf('y_a_d_n = %.3f x^{%.3f} / R^2 = %.3f',exp(p_first(2)),p_first(1),rsq_first),'Fontsize',40,'Color',colors_p(7,:))
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.MinorGridLineStyle = ':'
ax.MinorGridAlpha = 1
xlim([1*10^-2 1*10^1]);

%Percentage
all_first_perc = [Per_geo1(:,2);(Per_geo2(:,1)+Per_geo2(:,3))./2;(Per_geo3(:,2)+Per_geo3(:,4))./2;(Per_geo4(:,3)+Per_geo4(:,5))./2;Per_geo5(:,4);Per_geo6(:,7);(Per_geo7(:,6)+Per_geo7(:,8))./2;(Per_geo8(:,7)+Per_geo8(:,9))./2;(Per_geo9(:,8)+Per_geo9(:,10))./2;Per_geo10(:,9)];

%% Regression through all points
lmax = log(all_maxs);
lmax_first_perc = log(all_first_perc);
p_perc=polyfit(lmax,lmax_first_perc,1);
x_fitline_perc = lmax;
y_fitline_perc = p_perc(1)*x_fitline_perc+p_perc(2);
x_fitlog_perc = exp(x_fitline_perc);
y_fitlog_perc = exp(y_fitline_perc);
yfit_perc = polyval(p_perc,lmax);
yresid_perc = lmax_first_perc - yfit_perc;
SSresid_perc = sum(yresid_perc.^2);
SStotal_perc = (length(lmax)-1) * var(lmax);
rsq_perc = 1 - SSresid_perc/SStotal_perc;

% Figure 7b
figure
loglog(all_maxs,all_first_perc,'o','Linewidth',1,'Color',colors_p(7,:))
hold on
loglog(x_fitlog_perc,y_fitlog_perc,'Linewidth',2,'Color',colors_p(7,:))
grid on
box off
set(gca,'FontSize',40);
text(2*10^-2,2.5,sprintf('y_a_d_n = %.3f x^{%.3f} / R^2 = %.3f',exp(p_perc(2)),p_perc(1),rsq_perc),'Fontsize',40,'Color',colors_p(7,:))
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.MinorGridLineStyle = ':'
ax.MinorGridAlpha = 1
xlim([1*10^-2 1*10^1]);
yticks([1 5 10 20 30 40]);
yticklabels({'1','5','10','20','30','40'});
ylim([1 40]);
xticks([0.01 0.1 1 10])
xticklabels({'0.01','0.1','1','10'})
xlabel('A_m_a_x [V]');
ylabel('A_m_a_x 1st plate(s) [%]')

%% Second neighbouring geophone%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Absolute
all_maxs = [Geo1(:,1);Geo2(:,2);Geo3(:,3);Geo4(:,4);Geo5(:,5);Geo6(:,6);Geo7(:,7);Geo8(:,8);Geo9(:,9);Geo10(:,10)];
all_maxs_second = [Geo1(:,3);Geo2(:,4);(Geo3(:,1)+Geo3(:,5))./2;Geo4(:,2);Geo5(:,3);Geo6(:,8);Geo7(:,9);(Geo8(:,6)+Geo8(:,10))./2;Geo9(:,7);Geo10(:,8)];

lmax = log(all_maxs);
lmax_second = log(all_maxs_second);
p_second=polyfit(lmax,lmax_second,1);
x_fitline_second = lmax;
y_fitline_second = p_second(1)*x_fitline_second+p_second(2);
x_fitlog_second = exp(x_fitline_second);
y_fitlog_second = exp(y_fitline_second);
yfit_second = polyval(p_second,lmax);
yresid_second = lmax_second - yfit_second;
SSresid_second = sum(yresid_second.^2);
SStotal_second = (length(lmax)-1) * var(lmax);
rsq_second = 1 - SSresid_second/SStotal_second;

all_second_vdn = [all_maxs all_maxs_second];
%save all_second_vdn.mat all_second_vdn

% Figure 7c
figure
loglog(all_maxs,all_maxs_second,'o','Linewidth',1,'Color',colors_p(7,:))
hold on
loglog(x_fitlog_second,y_fitlog_second,'Linewidth',2,'Color',colors_p(7,:))
grid on
box off
xticklabels({'0.01','0.1','1','10'})
yticklabels({'0.001','0.01','0.1','1'})
xlabel('A_m_a_x [V]');
ylabel('A_m_a_x 2nd plate(s) [V]')
set(gca,'FontSize',40);
text(2*10^-2,5*10^-1,sprintf('y_a_d_n = %.3f x^{%.3f} / R^2 = %.3f',exp(p_second(2)),p_second(1),rsq_second),'Fontsize',40,'Color',colors_p(7,:))
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.MinorGridLineStyle = ':'
ax.MinorGridAlpha = 1
xlim([1*10^-2 1*10^1]);

% Percentage
all_second_perc = [Per_geo1(:,3);Per_geo2(:,4);(Per_geo3(:,1)+Per_geo3(:,5))./2;Per_geo4(:,2);Per_geo5(:,3);Per_geo6(:,8);Per_geo7(:,9);(Per_geo8(:,6)+Per_geo8(:,10))./2;Per_geo9(:,7);Per_geo10(:,8)];

lmax = log(all_maxs);
lmax_second_perc = log(all_second_perc);
p_second_perc=polyfit(lmax,lmax_second_perc,1);
x_fitline_second_perc = lmax;
y_fitline_second_perc = p_second_perc(1)*x_fitline_second_perc+p_second_perc(2);
x_fitlog_second_perc = exp(x_fitline_second_perc);
y_fitlog_second_perc = exp(y_fitline_second_perc);
yfit_second_perc = polyval(p_second_perc,lmax);
yresid_second_perc = lmax_second_perc - yfit_second_perc;
SSresid_second_perc = sum(yresid_second_perc.^2);
SStotal_second_perc = (length(lmax)-1) * var(lmax);
rsq_second_perc = 1 - SSresid_second_perc/SStotal_second_perc;

%Figure 7d
figure
loglog(all_maxs,all_second_perc,'o','Linewidth',1,'Color',colors_p(7,:))
hold on
loglog(x_fitlog_second_perc,y_fitlog_second_perc,'Linewidth',2,'Color',colors_p(7,:))
grid on
box off
set(gca,'FontSize',40);
text(2*10^-2,2.5*10^0,sprintf('y_a_d_n = %.3f x^{%.3f} / R^2 = %.3f',exp(p_second_perc(2)),p_second_perc(1),rsq_second_perc),'Fontsize',40,'Color',colors_p(7,:))
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.MinorGridLineStyle = ':'
ax.MinorGridAlpha = 1
xlim([1*10^-2 1*10^1]);
yticks([1 5 10 20 30 40]);
yticklabels({'1','5','10','20','30','40'});
ylim([1 40]);
xticks([0.01 0.1 1 10])
xticklabels({'0.01','0.1','1','10'})
xlabel('A_m_a_x [V]');
ylabel('A_m_a_x 2nd plate(s) [%]')

%% Third neighbouring geophone%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Absolute
all_maxs_3 = [Geo1(:,1);Geo2(:,2);Geo4(:,4);Geo5(:,5);Geo6(:,6);Geo7(:,7);Geo9(:,9);Geo10(:,10)];
all_maxs_third = [Geo1(:,4);Geo2(:,5);Geo4(:,1);Geo5(:,2);Geo6(:,9);Geo7(:,10);Geo9(:,6);Geo10(:,7)];

lmax_3 = log(all_maxs_3);
lmax_third = log(all_maxs_third);
p_third=polyfit(lmax_3,lmax_third,1);
x_fitline_third = lmax_3;
y_fitline_third = p_third(1)*x_fitline_third+p_third(2);
x_fitlog_third = exp(x_fitline_third);
y_fitlog_third = exp(y_fitline_third);
yfit_third = polyval(p_third,lmax_3);
yresid_third = lmax_third - yfit_third;
SSresid_third = sum(yresid_third.^2);
SStotal_third = (length(lmax_3)-1) * var(lmax_3);
rsq_third = 1 - SSresid_third/SStotal_third;

all_third_vdn = [all_maxs_3 all_maxs_third];
%save all_third_vdn.mat all_third_vdn

%Figure 7e
figure
loglog(all_maxs_3,all_maxs_third,'o','Linewidth',1,'Color',colors_p(7,:))
hold on
loglog(x_fitlog_third,y_fitlog_third,'Linewidth',2,'Color',colors_p(7,:))
grid on
box off
xticklabels({'0.01','0.1','1','10'})
yticks([0.001 0.01 0.1 1]);
yticklabels({'0.001','0.01','0.1','1'})
xlabel('A_m_a_x [V]');
ylabel('A_m_a_x 3rd plate(s) [V]')
set(gca,'FontSize',40);
text(2*10^-2,4*10^-1,sprintf('y_a_d_n = %.3f x^{%.3f} / R^2 = %.3f',exp(p_third(2)),p_third(1),rsq_third),'Fontsize',40,'Color',colors_p(7,:))
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.MinorGridLineStyle = ':'
ax.MinorGridAlpha = 1
xlim([1*10^-2 1*10^1]);
ylim([1*10^-3 1*10^0]);

% Percentage
all_third_perc = [Per_geo1(:,4);Per_geo2(:,5);Per_geo4(:,1);Per_geo5(:,2);Per_geo6(:,9);Per_geo7(:,10);Per_geo9(:,6);Per_geo10(:,7)];

lmax_3 = log(all_maxs_3);
lmax_third_perc = log(all_third_perc);
p_third_perc=polyfit(lmax_3,lmax_third_perc,1);
x_fitline_third_perc = lmax_3;
y_fitline_third_perc = p_third_perc(1)*x_fitline_third_perc+p_third_perc(2);
x_fitlog_third_perc = exp(x_fitline_third_perc);
y_fitlog_third_perc = exp(y_fitline_third_perc);
yfit_third_perc = polyval(p_third_perc,lmax_3);
yresid_third_perc = lmax_third_perc - yfit_third_perc;
SSresid_third_perc = sum(yresid_third_perc.^2);
SStotal_third_perc = (length(lmax_3)-1) * var(lmax_3);
rsq_third_perc = 1 - SSresid_third_perc/SStotal_third_perc;

%Figure 7f
figure
loglog(all_maxs_3,all_third_perc,'o','Linewidth',1,'Color',colors_p(7,:))
hold on
loglog(x_fitlog_third_perc,y_fitlog_third_perc,'Linewidth',2,'Color',colors_p(7,:))
grid on
box off
set(gca,'FontSize',40);
text(2*10^-2,1.5*10^0,sprintf('y_a_d_n = %.3f x^{%.3f} / R^2 = %.3f',exp(p_third_perc(2)),p_third_perc(1),rsq_third_perc),'Fontsize',40,'Color',colors_p(7,:))
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.MinorGridLineStyle = ':'
ax.MinorGridAlpha = 1
xlim([1*10^-2 1*10^1]);
yticks([1 5 10 20 30 40]);
yticklabels({'1','5','10','20','30','40'});
ylim([1 40]);
xticks([0.01 0.1 1 10])
xticklabels({'0.01','0.1','1','10'})
xlabel('A_m_a_x [V]');
ylabel('A_m_a_x 3rd plate(s) [%]')

%% Fourth neighbouring geophone%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Absolute
all_maxs_4 = [Geo1(:,1);Geo5(:,5);Geo6(:,6);Geo10(:,10)];
all_maxs_fourth = [Geo1(:,5);Geo5(:,1);Geo6(:,10);Geo10(:,6)];

lmax_4 = log(all_maxs_4);
lmax_fourth = log(all_maxs_fourth);
p_fourth=polyfit(lmax_4,lmax_fourth,1);
x_fitline_fourth = lmax_4;
y_fitline_fourth = p_fourth(1)*x_fitline_fourth+p_fourth(2);
x_fitlog_fourth = exp(x_fitline_fourth);
y_fitlog_fourth = exp(y_fitline_fourth);
yfit_fourth = polyval(p_fourth,lmax_4);
yresid_fourth = lmax_fourth - yfit_fourth;
SSresid_fourth = sum(yresid_fourth.^2);
SStotal_fourth = (length(lmax_4)-1) * var(lmax_4);
rsq_fourth = 1 - SSresid_fourth/SStotal_fourth;

all_fourth_vdn = [all_maxs_4 all_maxs_fourth];
%save all_fourth_vdn.mat all_fourth_vdn

%Figure 7g
figure
loglog(all_maxs_4,all_maxs_fourth,'o','Linewidth',1,'Color',colors_p(7,:))
hold on
loglog(x_fitlog_fourth,y_fitlog_fourth,'Linewidth',2,'Color',colors_p(7,:))
grid on
box off
xlabel('Max. amp. impact [V]');
ylabel('Max. amp. 4th plate(s) [V]')
set(gca,'FontSize',40);
text(2*10^-2,4*10^-1,sprintf('y_a_d_n = %.3f x^{%.3f} / R^2 = %.3f',exp(p_fourth(2)),p_fourth(1),rsq_fourth),'Fontsize',40,'Color',colors_p(7,:))
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.MinorGridLineStyle = ':'
ax.MinorGridAlpha = 1
xticks([0.01 0.1 1 10]);
xticklabels({'0.01','0.1','1','10'})
yticks([0.001 0.01 0.1 1]);
yticklabels({'0.001','0.01','0.1','1'})
xlabel('A_m_a_x [V]');
ylabel('A_m_a_x 4th plate(s) [V]')

% Percentage
all_fourth_perc = [Per_geo1(:,5);Per_geo5(:,1);Per_geo6(:,10);Per_geo10(:,6)];

lmax_4 = log(all_maxs_4);
lmax_fourth_perc = log(all_fourth_perc);
p_fourth_perc=polyfit(lmax_4,lmax_fourth_perc,1);
x_fitline_fourth_perc = lmax_4;
y_fitline_fourth_perc = p_fourth_perc(1)*x_fitline_fourth_perc+p_fourth_perc(2);
x_fitlog_fourth_perc = exp(x_fitline_fourth_perc);
y_fitlog_fourth_perc = exp(y_fitline_fourth_perc);
yfit_fourth_perc = polyval(p_fourth_perc,lmax_4);
yresid_fourth_perc = lmax_fourth_perc - yfit_fourth_perc;
SSresid_fourth_perc = sum(yresid_fourth_perc.^2);
SStotal_fourth_perc = (length(lmax_4)-1) * var(lmax_4);
rsq_fourth_perc = 1 - SSresid_fourth_perc/SStotal_fourth_perc;

%Figure 7h
figure
loglog(all_maxs_4,all_fourth_perc,'o','Linewidth',1,'Color',colors_p(7,:))
hold on
loglog(x_fitlog_fourth_perc,y_fitlog_fourth_perc,'Linewidth',2,'Color',colors_p(7,:))
grid on
box off
set(gca,'FontSize',40);
text(2*10^-2,1.5*10^0,sprintf('y_a_d_n = %.3f x^{%.3f} / R^2 = %.3f',exp(p_fourth_perc(2)),p_fourth_perc(1),rsq_fourth_perc),'Fontsize',40,'Color',colors_p(7,:))
ax = gca
ax.GridLineStyle = '-'
ax.GridColor = 'k'
ax.GridAlpha = 0.5 % maximum line opacity
ax.MinorGridLineStyle = ':'
ax.MinorGridAlpha = 1
%xlim([2*10^-1 1*10^1]);
yticks([1 5 10 20 30 40]);
yticklabels({'1','5','10','20','30','40'});
ylim([1 40]);
xticks([0.01 0.1 1 10])
xticklabels({'0.01','0.1','1','10'})
xlabel('A_m_a_x [V]');
ylabel('A_m_a_x 4th plate(s) [%]')
